import java.util.LinkedHashMap;

/**
 * Lab #6
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class models Olympic Teams.
 * </P>
 * @version 1.0
 */
public class OlympicTeam {
	// TODO:  Make this class serializable
	private String country;
	private LinkedHashMap<String, OlympicAthlete> roster;

	public OlympicTeam (){
		country = "";
		roster = new LinkedHashMap<String, OlympicAthlete>();
	}

	/**
	 * @param country
	 * @param roster
	 */
	public OlympicTeam(String country, LinkedHashMap<String, OlympicAthlete> roster) {
		this.country = country;
		this.roster = roster;
	}

	/**
	 * @return the country
	 */
	public String getCountry() {
		return country;
	}

	/**
	 * @param country the country to set
	 */
	public void setCountry(String country) {
		this.country = country;
	}

	/**
	 * @return the roster
	 */
	public LinkedHashMap<String, OlympicAthlete> getRoster() {
		return roster;
	}

	/**
	 * @param roster the roster to set
	 */
	public void setRoster(LinkedHashMap<String, OlympicAthlete> roster) {
		this.roster = roster;
	}
	
	public boolean contains(String athleteName) {
		return roster.containsKey(athleteName);
	}
	
	public String getAthleteString(String athleteName) {
		return roster.get(athleteName).toString();
	}
	
	public void addToRoster(OlympicAthlete athlete) {
		roster.put(athlete.getName(), athlete);
	}
	
	public void replaceInRoster(OlympicAthlete athlete) {
		roster.put(athlete.getName(), athlete);
	}
	
	public void addToAthleteHistory(String athleteName, EventRecord newEvent) {
		roster.get(athleteName).addToHistory(newEvent);
	}
	
	public void clearRoster() {
		roster = new LinkedHashMap<String, OlympicAthlete>();
	}
	
	// TODO:  Add methods for object input and output
	
	// TODO:  Add method for printing to the console
}