import java.awt.event.*;

import javax.swing.JOptionPane;

/**
 * Lab #6
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class is the controller for the Olympic Team software.
 * </P>
 * @version 1.0
 */
public class OlympicTeamController {
	private OlympicTeamModel model;
	private OlympicTeamInputWindow teamInputView;
	
	/** Creates new OlympicTeamController */
	public OlympicTeamController() {
		// intentionally empty
	}

	public void setModel(OlympicTeamModel model) {
		this.model = model;
	}

	public OlympicTeamModel getModel() {  // future use
		return model;
	}

	private class AddAthleteListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.
			
			String name = teamInputView.jtfName.getText();
			String medal = (String) teamInputView.jcbMedal.getSelectedItem();
			String event = teamInputView.jtfEvent.getText();
			
			if (model.contains(name)) {  // Athlete already in roster so ask what to do
				
				// TODO: Use a JOptionPane here to ask what to do 
				
				int response;

				if (response == 0) {
					// option 0 is cancel so do nothing
				}
				else if (response == 1) {
					// TODO: call mutator method to replace athlete (note that option 1 should be replace)
					
				}
				else if (response == 2) {
					// TODO: call mutator method to add event to athlete's history (option 2 should be add to history)
					
				}
				else {
					// Should handle error case here (we won't for this lab).
				}
			}
			else {  // Athlete not in roster, so add
				model.addToRoster(new OlympicAthlete(name, event, medal));
			}
		}
	}
	
	private class ClearRosterListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.
			model.clearRoster();
		}
	}
	
	private class ClearInputFieldsListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			teamInputView.clearInputFields();
		}
	}
	
	// TODO:  Create additional listener classes for menu and toolbar.

	public void setTeamInputWindow(OlympicTeamInputWindow teamInputView) {
		this.teamInputView = teamInputView;
		
		// Register listeners
		this.teamInputView.getAddAthleteButton().addActionListener(new AddAthleteListener());
		this.teamInputView.getClearInputButton().addActionListener(new ClearInputFieldsListener());
		this.teamInputView.getClearRosterButton().addActionListener(new ClearRosterListener());
		
		// TODO: Register additional listeners for menu and toolbar.
		
	}

	public OlympicTeamInputWindow getTeamInputWindow() {  // future use
		return teamInputView;
	}
}